#include <EditConstants.au3>
#include <GUIConstantsEx.au3>
#include <ExchangeVariables.au3>

Global $Variable

$hGui = GUICreate('Script 1', 320, 360, @DesktopWidth / 2 - 320 - 50)
GUICtrlCreateLabel("Variable Type", 10, 10, 300, 20)
$hCombo = GUICtrlCreateCombo("", 10, 30, 300, 20)
GUICtrlSetData($hCombo, "Array|Int32|Int64|Double|String|Binary|Ptr|DLLStruct|Object|Bool|Keyword")
GUICtrlCreateLabel("Variable Info", 10, 70, 300, 20)
$hEdit = GUICtrlCreateEdit("", 10, 90, 300, 220, $ES_READONLY)
$hButton = GUICtrlCreateButton("Send variable to script 2", 10, 320, 300, 30)
GUISetState()

_ExchangeVariables_Startup(1, 'ExchangeVariables Example 2')

While 1
	$msg = GUIGetMsg()
	Switch $msg
		Case $GUI_EVENT_CLOSE
			Exit
		Case $hCombo
			$Variable = _CreateVariable(GUICtrlRead($hCombo))
			_DisplayVariable($Variable)
		Case $hButton
			_ExchangeVariables_SetVariable(2, "Variable", $Variable, "int")
	EndSwitch
WEnd


Func _CreateVariable($sType)
	Switch $sType
		Case "Array"
			Local $aReturn[3][4] = [[1, 2, 3, 4],[5, 6, 7, 8],[9, 10, 11, 12]]
			Return $aReturn
		Case "Int32"
			Return 10
		Case "Int64"
			Return Int("10")
		Case "Double"
			Return 0.123
		Case "String"
			Return "Hello World"
		Case "Binary"
			Return Binary("Hello World")
		Case "Ptr"
			Return Ptr(10)
		Case "DLLStruct"
			Local $tReturn = DllStructCreate("int")
			DllStructSetData($tReturn, 1, 10)
			Return $tReturn
		Case "Object"
			Local $oReturn = ObjCreate('Scripting.Dictionary')
			$oReturn.Add("Hello", "Hello World")
			Return $oReturn
		Case "Bool"
			Return False
		Case "Keyword"
			Return Default
	EndSwitch
EndFunc   ;==>_CreateVariable

Func _DisplayVariable($Variable)
	Local $sInfo = "Variable Type: " & VarGetType($Variable) & @CRLF & @CRLF & "Data:" & @CRLF
	Switch VarGetType($Variable)
		Case "Array"
			For $i = 0 To 2
				For $j = 0 To 3
					$sInfo &= "Array[" & $i & "][" & $j & "] = " & $Variable[$i][$j] & @CRLF
				Next
			Next
		Case "DllStruct"
			$sInfo &= "Size: " & DllStructGetSize($Variable) & @CRLF
			$sInfo &= "Ptr:  " & DllStructGetPtr($Variable) & @CRLF
			$sInfo &= "Data: " & DllStructGetData($Variable, 1)
		Case "Object"
			$sInfo &= "Name: " & ObjName($Variable) & @CRLF
			$sInfo &= "Data: " & $Variable.Item("Hello")
		Case Else
			$sInfo &= $Variable
	EndSwitch
	GUICtrlSetData($hEdit, $sInfo)
EndFunc   ;==>_DisplayVariable
