#include <EditConstants.au3>
#include <GUIConstantsEx.au3>
#include <ExchangeVariables.au3>

Global $Variable = 'Hello World'

$hGui = GUICreate('Script 2', 320, 300, @DesktopWidth / 2 + 50)
GUICtrlCreateLabel("Variable Info", 10, 10, 300, 20)
$hEdit = GUICtrlCreateEdit("", 10, 30, 300, 220, $ES_READONLY)
$hButton = GUICtrlCreateButton("Get variable from script 1", 10, 260, 300, 30)
GUISetState()

_ExchangeVariables_Startup(2, 'ExchangeVariables Example 2', '_VarMsg')

While 1
	$msg = GUIGetMsg()
	Switch $msg
		Case $GUI_EVENT_CLOSE
			_ExchangeVariables_Shutdown()
			Exit
		Case $hButton
			$Variable = _ExchangeVariables_GetVariable(1, "Variable", "int")
			_DisplayVariable($Variable)
	EndSwitch
WEnd


Func _VarMsg($hWnd, $iMsg, $wParam, $lparam)
	_DisplayVariable($Variable)
EndFunc   ;==>_VarMsg


Func _DisplayVariable($Variable)
	Local $sInfo = "Variable Type: " & VarGetType($Variable) & @CRLF & @CRLF & "Data:" & @CRLF
	Switch VarGetType($Variable)
		Case "Array"
			For $i = 0 To 2
				For $j = 0 To 3
					$sInfo &= "Array[" & $i & "][" & $j & "] = " & $Variable[$i][$j] & @CRLF
				Next
			Next
		Case "DllStruct"
			$sInfo &= "Size: " & DllStructGetSize($Variable) & @CRLF
			$sInfo &= "Ptr:  " & DllStructGetPtr($Variable) & @CRLF
			$sInfo &= "Data: " & DllStructGetData($Variable, 1)
		Case "Object"
			$sInfo &= "Name: " & ObjName($Variable) & @CRLF
			$sInfo &= "Data: " & $Variable.Item("Hello")
		Case Else
			$sInfo &= $Variable
	EndSwitch
	GUICtrlSetData($hEdit, $sInfo)
EndFunc   ;==>_DisplayVariable